#INCLUDE "dcdialog.CH"
#include "APPEVENT.CH"

#define TRUE  .T.
#define FALSE .F.


Static snCount := 0


FUNCTION Main()

LOCAL GetList[0], cGet := Space(50), aDir := Directory(), oBrowse
Local nDelay := 0.8

@ 0,0 DCGET cGet KEYBLOCK {|nKey,x,oGet| _MyKeyBlock(nKey,nDelay,oGet,oBrowse)}

@ 2,0 DCBROWSE oBrowse DATA aDir SIZE 60,25

DCBROWSECOL ELEMENT 1 HEADER 'File Name' WIDTH 50 PARENT oBrowse

wtf 'start'

DCREAD GUI FIT

RETURN nil

* ----------

PROC appsys ; return


*********************
Procedure _MyKeyblock( nKey, _nDelay, oGet, oBrowse )
*********************

LOCAL oTimer  := Sy_Timer():New()
LOCAL nDelay  := _nDelay   
LOCAL nEvent := 0
LOCAL mp1, mp2, oXbp
LOCAL cSeek  := oGet:EditBuffer()  // Content of current DCGET object

wtf nKey

snCount ++
wtf snCount, cSeek  && , Len( cSeek )

         oTimer:Mark(nDelay)
         do while !oTimer:Timeout()
            nEvent   := NextAppEvent( @mp1, @mp2, @oXbp )
            if nEvent <> xbe_None
               nEvent   := AppEvent( @mp1, @mp2, @oXbp )
               if ValType(oXbp) = "O"
                  if nEvent = xbeP_Keyboard                                   // a Key was hit
                     oTimer:Mark(nDelay)                                      // Reset timeout
                     do case
                        case mp1 = 13
                           nKey  := xbeK_ENTER
                           exit
                        case mp1 = xbeK_BS
                           if !Empty(oXbp:EditBuffer())
                              oXbp:HandleEvent(nEvent,mp1,mp2)
                           endif
                        case mp1 <> 10
                           oXbp:HandleEvent(nEvent,mp1,mp2)
                     endcase
                  else
                     oXbp:HandleEvent(nEvent,mp1,mp2)
                  endif
               endif
            endif
         enddo

      cSeek := oGet:editbuffer()
wtf cSeek
*      lSoftSeek := Set(_SET_SOFTSEEK,.t.)
*      SEEK AllTrim(cSeek))
*      Set(_SET_SOFTSEEK,lSoftSeek)
oBrowse:refreshAll()

wtf 'oBrowse refreshed'

snCount := 0

Return

*

CLASS Sy_Timer
HIDDEN:
VAR      nStartTime
VAR      nStopTime
VAR      dStart
VAR      lEnable
INLINE METHOD Now ; Return ((Date() - ::dStart) * 86400) + Seconds()          // Current elapsed in seconds

EXPORTED:
METHOD   Init
METHOD   Mark                                                                 // Mark timerout in seconds
METHOD   TimeOut                                                              // Check timout elapsed
METHOD   MarkTime                                                             // Mark timout in hh:mm:ss
METHOD   EndTime                                                              // Date and time of timeout moment
INLINE METHOD   Enable ; ::lEnable := TRUE   ; Return                         // Enable Timer
INLINE METHOD  Disable ; ::lEnable := FALSE  ; Return                         // Disable Timer
VAR      Cargo
ENDCLASS

METHOD   Sy_Timer:Init()
::dStart                := Date()                                             // Date of instance create
::Mark()                                                                      // Set marker
Return SELF

METHOD   Sy_Timer:Mark(nTimeout)                                               // Mark start-time
If (nTimeOut==NIL)
   nTimeOut := 0
EndIf
::nStartTime            := ::Now()                                            // Save current time
::nStopTime             := ::nStartTime + nTimeOut                            // Calculate stop time
::Enable()                                                                    // Enable Time-out
Return

METHOD   Sy_Timer:TimeOut(nTimeOut)
LOCAL nNow              := ::Now()                                            // Capcure now in seconds
if ValType(nTimeOut) = "N"                                                    // Alternative timeout in seconds
   Return (nNow >= (::nStartTime + nTimeOut))                                 // nTimeout passed marker ?
endif
Return ::lEnable .and. (nNow >= ::nStopTime)

METHOD   Sy_Timer:EndTime()                                                    // Text persentation of timout moment
LOCAL cRet              := ""
LOCAL nSecs             := ::nStopTime                                        // Current timeout in seconds
LOCAL nDays             := 0
LOCAL nHours            := 0
LOCAL nMins             := 0

nDays                   := Int(nSecs /86400)   ; nSecs -= (nDays   * 86400)
nHours                  := Int(nSecs / 3600)   ; nSecs -= (nHours  *  3600)
nMins                   := Int(nSecs /   60)   ; nSecs -= (nMins   *    60)

if nDays > 0
   cRet                 := Dtoc(::dStart + nDays) + " "
endif
cRet                    += StrZero(nHours,2)    + ":"
cRet                    += StrZero(nMins,2)
if nSecs > 0
   cRet                 += ":" + StrZero(nSecs,2)
endif
Return cRet

METHOD   Sy_Timer:MarkTime(cTime,dDate)
//
// cTime = HH:MM:SS
// dDate = Date() (Optional)
//
LOCAL nSecs             := 0
If ( Date() == NIL )
   dDate := Date()
EndIf
cTime                   := Padr(cTime,8,"0")                                  // Add "0" if absent
nSecs                   := Val(Substr(cTime,1,2)) * 3600                      // Hours
nSecs                   += Val(SubStr(cTime,4,2)) * 60                        // Minutes
nSecs                   += Val(SubStr(cTime,7,2))                             // Seconds
::nStopTime             := ((dDate - ::dStart) * 86400) + nSecs               // Stop-time
::Enable()                                                                    // Enable Time-out
Return

*

// EOF